/*
	2013/7/18   Shinji Ushimaru
*/

#include "uss.h"
#include "motor.h"
#include "img.h"
#include "ts_ws.h"
#include "area.h"
#include "mirs.h"

#include "controller.h"

enum Area {PASSWAY, DR, KEYDOOR, ROOM , ROTARY, RETURN};

int controller(){

	int ret;
	int speed,dist;
	int uss1, uss2;
	int count=0;
	int sn =0;

	enum Area area=PASSWAY;

	speed=20;
	dist=2000;

        motor_send_start_packet(fd1);
        motor_send_start_packet(fd2);

	while(1){
		switch (area) {
			case PASSWAY:
				area_passway();
				break;
			case DR:
				area_dr();
				break;
			case KEYDOOR:
				area_keydoor();
				break;
			case ROOM:
				area_room();
				break;
			case ROTARY:
				area_rotary();
				break;
			case RETURN:
				area_return();
				break;
		}
		usleep(1000);
	}

        motor_send_start_packet(fd1);
        motor_send_start_packet(fd2);

	return 0;
}


