#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <time.h>
#include "uss.h"
#include "motor.h"
#include "run.h"
#include "io_read.h"
#include "mirs.h"
#include "controller.h"
#include "img.h"
#include "compass.h"
#include "coordinates.h"

extern Motor* motor_l;
extern Motor* motor_r;

void brake(void);
void straight(float x,double dir);
void straight_ts(float x,double dir);
void rotate(float angle);

int junkai(){
	clock_t start_time;
	start_time = clock();
	


/*************巡回スタート***************/

	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}

	rotate(270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
//	capture_image(1);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(1000,270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	rotate(0);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(1500,0);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	rotate(270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	capture_image(3);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(100,270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	rotate(0);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(2500,0);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
//	capture_image(5);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	rotate(270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	capture_image(4);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(500,270);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	rotate(90);
	if(clock() - start_time >=180*1000*1000){
		printf("3分経過");
		return 0;
	}
	straight_ts(1500,90);



/*
	capture_image(3);
	capture_image(2);
	capture_image(4);
	capture_image(5);
*/


	return 0;
}

void brake(void){
	motor_brake(motor_l);
	motor_brake(motor_r);
}

void straight(float x,double dir){
	float x_margin = 10;
	float speed = 15;
	RunStatus* status;
	brake();
	status = run_straight_init(motor_l,motor_r);
	while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,dir,status)) );
	run_straight_finish(status);
}


void straight_ts(float x,double dir){
	float x_margin = 10;
	float speed = 15;
	RunStatus* status;
	printf("前進します。\n");
	brake();
	status = run_straight_init(motor_l,motor_r);
	while( fabs(x_margin) < fabs(x - run_straight_to(x,speed,dir,status)) ){
		io_read();
		if(io_data[9] == '1'){ 
			printf("正面の壁に衝突したので後退します。\n");
			straight(-100,angle);
			break;
		}
		if(io_data[10] == '1'){
			printf("左の壁に衝突したので後退して向きを変えます。\n");
			straight(-100,angle);
			rotate(angle+20);
		}
		if(io_data[8] == '1'){
			printf("右の壁に衝突したので後退して向きを変えます。\n");
			straight(-100,angle);
			rotate(angle-20);
		}
	}
	run_straight_finish(status);
}

void rotate(float angle){
	float angle_margin = 1;
	float speed = 15;
	RunStatus* status;
	brake();
	status = run_rotate_init(motor_l,motor_r);
	while( fabs(angle_margin) < fabs(angle - run_rotate_to(angle,speed,status)) );
	run_rotate_finish(status);
}


