/*
通路走行

	動作のアルゴリズム
	・指定距離になるまで直進する。
	・直進中に、左右のタッチセンサが反応したら、少し下がって方向を変え、自己位置を修正する。

*/
#include "area.h"
#include "run.h"
#include "controller.h"
#include "mirs.h"
#include "uss.h"
#include "io_read.h"
#include "motor.h"

int area_passway(void){

	int uss1,uss2,uss3;
	int ts_center, ts_right, ts_left;

	float speed,x,x_margin;
	double angle_ref;

	printf("Start Area_Passway\n");

//	run_init();
//	run_straight_set(speed);	

//	run_straight();	

	//指定された距離まで直進（繰り返し呼ぶ）

	io_read(); //IO データの取得
	ts_left=io_data[8];
	ts_center=io_data[9];
	ts_right=io_data[10];
	//タッチセンサに反応したら少し下がって、向きを変え、自己位置を補正する。
	if(ts_center=='1'){
		printf("TS_CENTER detected\n");
//		run_sp_rotate(par);
	}
	if(ts_right=='1'){
		printf("TS_RIGHT detected\n");
//		run_sp_rotate(par);
	}
	if(ts_left=='1'){
		printf("TS_LEFT detected\n");
//		run_sp_rotate(par);
	}
	
//	run_stop();
	return 0;

}
