//headders
#include <stdio.h>
#include <string.h>
#include <highgui.h>
#include <cv.h>
#include <cxcore.h>
#include <ball_detect_extern.h>
//Camera
#define CAM_WIDTH	320
#define CAM_HEIGHT	240
//col_threshold用
#include<threshold_value.h>
//cvCanny用定数
#define CANNY_THRESHOLD1	50
#define CANNY_THRESHOLD2	100
#define APERTURE_SIZE		3
//cvSmooth用定数
#define SMOOTH_PARAM1		9
#define SMOOTH_PARAM2		9

double ball_detect(double *white_rate, int *lsl,int *lsr,int *rsl,int *rsr, int  my_target){
	int nx, ny;
	int key;
	double white_rate_detect=0;
	short *labeling_data=NULL;
	char *filename = "thief.jpg";
	IplImage *inputImage = 0,
			 *thresholdImage,
			 *cannyImage,
			 *smoothImage;

	

	
	img_update(filename, CAM_WIDTH, CAM_HEIGHT);

	if(inputImage == 0){
		inputImage = cvLoadImage(filename, CV_LOAD_IMAGE_ANYCOLOR);
		thresholdImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
		cannyImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
		smoothImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
		nx = inputImage->width; 
		ny = inputImage->height;
		labeling_data = (short*)malloc(sizeof(short)*nx*ny);
	}
	
	//main関数で自分のモード（赤or青）を把握する変数 char my_targetを定義したと仮定する。
	
	//col_threshold
	if(my_target == 'r'){
	col_threshold(inputImage, thresholdImage, R_TARGET_TH1_MIN, R_TARGET_TH1_MAX, R_TARGET_TH2_MIN, R_TARGET_TH2_MAX, R_TARGET_TH3_MIN, R_TARGET_TH3_MAX, R_TARGET_TH_CODE,  white_rate, lsl, lsr, rsl, rsr);
	}else if(my_target == 'b'){
	col_threshold(inputImage, thresholdImage, B_TARGET_TH1_MIN, B_TARGET_TH1_MAX, B_TARGET_TH2_MIN, B_TARGET_TH2_MAX, B_TARGET_TH3_MIN, B_TARGET_TH3_MAX, B_TARGET_TH_CODE,  white_rate, lsl, lsr, rsl, rsr);
	}else{
		printf("target_color.txtにターゲットの色が正しく入力されていません。\n");
	}


	//Erode & Dilate
	cvErode(thresholdImage, thresholdImage, NULL, 2);
	cvDilate(thresholdImage, thresholdImage, NULL, 5);

	//Canny	edge
	cvCanny(thresholdImage, cannyImage, CANNY_THRESHOLD1, CANNY_THRESHOLD2, APERTURE_SIZE);

	//Smooth
	cvSmooth(cannyImage, smoothImage, CV_GAUSSIAN, SMOOTH_PARAM1, SMOOTH_PARAM2, 0, 0);


	//quit program
	key = cvWaitKey(10);

	
	free(labeling_data);
	cvReleaseImage(&inputImage);
	cvReleaseImage(&thresholdImage);
	cvReleaseImage(&cannyImage);
	cvReleaseImage(&smoothImage);


	return 0;
}
