/*********************************************/
/*  IRS & TS & WS Device Driver Header Program    */
/*                                           */
/*                  developed by Eri.Taguchi */
/*                     ver 1.0  Dec. 16 2000 */
/*                  developed by Shinji Ushimaru */
/*                     ver 1.0  Mar. 16 2004 */
/*********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>

// DEBUG モード使用するときに define する。使用しない場合はコメントアウトする。
//#define __DEBUG_IO__

#define IRS_TS_WS_MAJOR 61
#define LEN 12//13
#define LINECOUNT 1

#define IRS_TS_WS_PORT_READ1 0x0310
#define IRS_TS_WS_PORT_READ2 0x0312
//#define IRS_TS_WS_PORT_MASK 0x0142

#define IRS_TS_WS_IOC_MAGIC 'i'
#define IO_READ1         _IOR(IRS_TS_WS_IOC_MAGIC, 0,unsigned long)//unsigned short int
#define IO_READ2         _IOR(IRS_TS_WS_IOC_MAGIC, 1,unsigned long)
#define TS_READ          _IOR(IRS_TS_WS_IOC_MAGIC, 2,unsigned long)
#define IRS_TS_WS_HARDRESET _IO(IRS_TS_WS_IOC_MAGIC,  4)
#define LCD_IOC_MAXNR 3

extern void io_read(); // ON/OFF IO データの読み取り

//ON/OFF IO の読み取り値（1 or 0）の入った変数
extern char io_data[12];
//extern volatile char io_data[12];

//デバイスファイル
extern int fd4;
