/*
正体補正のテストプログラム
	2013/7/11   Shinji Ushimaru
*/

//#include "controller.h"
#include "mirs.h"
#include "uss.h"
#include "motor.h"
#include "run.h"

//extern int theta_data;

int run_face_correct(int ussno1, int ussno2, int speed){

	//int ret;
	int uss1=0, uss2=999;
	int count=0;
	int sn =0;
	int par[4];

        motor_send_start_packet(fd1);
        motor_send_start_packet(fd2);

	par[0]=speed;
	run_rotate_set(par);

	//usleep(500*1000); // uss にデータが入るまで少し待つ（必須）

	while(1){
		uss1=uss_get(ussno1);
		usleep(30*1000);
		uss2=uss_get(ussno2);
		usleep(30*1000);
		printf("uss1=%d   uss2=%d   diff_uss12=%d\n",uss1,uss2,uss1-uss2);

		if(count==0){
			sn=uss1-uss2;  //最初のデータを記録する
		}
		// 正面の超音波センサの値の差がなくなるか、符号が変わったところで break する。
		//if(abs(uss1-uss2)<=1 || sn*(uss1-uss2)<0){ //差が１
		//if(abs(uss1-uss2)==0 || sn*(uss1-uss2)<0){ //差がゼロ
		//if(abs(uss1-uss2)<=2 ){ //差が1
		if(abs(uss1-uss2)==0 ){ //差が0
			motor_send_stop_packet(fd1);
			motor_send_stop_packet(fd2);
			break;
		}
		if(count>20){
			printf("face correction failed\n") ;
			return -1;
		}

		run_rotate(); //その場回転
		count++;
		usleep(50*1000);
		//usleep(130*1000);
	}

	return 0;
}
