#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include "motor.h"
#include "mirs.h"
#include "controller.h"

pthread_t motor_task;
pthread_attr_t attr_motor;
struct sched_param sched_param;

int main(void){

	int spl;
	int spr;

	/*
	printf("left speed = ");
	scanf("%d",&spl);
	printf("riget speed = ");
	scanf("%d",&spr);
	printf("\n");
	*/
	spl=0;
	spr=0;

	printf("spl=%d, spr=%d\n",spl,spr);

	//pthread_mutex_init(mutex_m,NULL);

/*
	pthread_attr_init (&attr_motor);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor, &sched_param);
*/

	printf("opening device...\n");
	fd1 = open(MOTOR_L_DEV_FILE, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(MOTOR_R_DEV_FILE, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");
		
	printf("starting...\n");

	//motor(c, val, t);

        motor_send_start_packet (fd1);
        motor_send_start_packet (fd2);
 
	motor_send_control_packet(fd1,spl,Kp,Ki);
	usleep(1000);
	motor_send_control_packet(fd2,spr,Kp,Ki);

        motor_send_stop_packet (fd1);
        motor_send_stop_packet (fd2);
 
	printf("end\n");
	
	printf("closing device...\n");
	close(fd1);
	close(fd2);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}
