/*
	超音波センサテスト
*/

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "mirs.h"
#include "uss.h"

//待ち時間
#define S_TIME 500000

int main(){

	int i,uss_data3[4];


	struct termios oldtio;
	unsigned char rs_rbuffer[2];
	unsigned char rs_sbuffer[1];

	int uss_num=2;

	sprintf((char*)rs_sbuffer,"%c",(char)uss_num);

	fd0=open(S_PORT,O_RDWR | O_NOCTTY | O_NONBLOCK);
	if(fd0<0){
		printf("device open error\n");
		return -1;
	}
	set_serial_port(fd0,&oldtio);
	put_serial_string(fd0,(char*)rs_sbuffer);

	while(1){

		for(i=0;i<3;i++){
		//for(i=2;i<3;i++){
		//	uss_data3[i]=uss_get(i+1);
			usleep(S_TIME);
			printf("uss[%d] = %d\n",i+1,uss_data3[i]);
		}
		printf("\n");

	}

	close_serial_port(fd0,&oldtio);



	return 0;
}
