/*
	超音波センサテスト
*/

#include "mirs.h"
#include "uss.h"

//待ち時間

int main(){

	int i;
	int S_TIME=500*1000;
	int uss_max=4;
	struct sched_param sched_param;

        //USSスレッドの属性の設定
        pthread_attr_init (&attr_uss);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
        pthread_attr_setschedparam (&attr_uss, &sched_param);

        //USSスレッドの生成
        printf("uss thread create..\n");
        pthread_create(&uss_task, &attr_uss, (void *)uss_read_thread, (void *)uss_max);

	while(1){


		for(i=0;i<4;i++){
			printf("uss[%d] = %d\n",i+1,uss[i]);
		}

		usleep(S_TIME);
		printf("\n");

	}

	pthread_join(uss_task,NULL);

	return 0;
}
